QGIS Application - Bug report #13707
Data dependent styling of vector layers broken after upgrade to 2.12 from 2.10
2015-10-29 05:30 AM - David Trethewey

Status: Closed

Priority: Normal

Assignee: Nyall Dawson

Category: Symbology

Affected QGIS version:master Regression?: No
Operating System: Linux Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 21734
Description

| recently upgraded to QGIS 2.12 from 2.10 on Ubuntu 15.04 and one of my projects lost the data dependent overrides on the linewidth
and colour of a line pattern fill of a vector layer.

| have a digital elevation model which | segmented and processed to a vector polygon layer, and used the average slope, slope direction,
and curvature from the attribute table to style a line pattern fill, and an SVG marker line pattern fill.

This drew arrows in the downslope direction, which were thicker for steeper slopes, and coloured according to the longitudinal curvature.
An example can be seen at my blog: [[http://skrifennow.blogspot.co.uk/2015/10/a-greyscale-version-of-my-maps-in.html]]

| use the following expressions:
for colour: case when RAT_LngtCrv_Mean > 0 then color_rgb(min(255,255*5*RAT_LngtCrv_Mean),0,0) else
color_rgb(0,0,min(255,-255*5*RAT_LngtCrv_Mean)) end

for linewidth (using map units - metres): case when RAT_Slope_deg_Mean > 2.25 then max(20*((RAT_Slope_deg_Mean - 2.25)/
90),0.4) else 0.0001 end

for size of the SVG arrow: case when "RAT_Slope_deg_Mean" > 2.25 then max(75*sqrt((RAT_Slope_deg_Mean - 2.25)/ 90),5) else
0.0001 end

for angle (working): 90 - RAT_Aspect_deg_mean

However after upgrading to QGIS 2.10, the data dependent styling of the line fill has disappeared as seen in the attached file. There is
only the default black colour and linewidth, although the slope direction still works.

| am wondering if this is a bug?

Associated revisions

Revision 2ac59332 - 2015-11-03 08:56 PM - Nyall Dawson

Fix data defined overrides for sub symbols in line and marker fill

are not being applied (fix #13707)

Revision 9e84fcaf - 2015-11-04 06:03 AM - Nyall Dawson

Followup 2ac5933 with more data defined fixes

2ac5933 fixed the regression in 2.12, but there were more underlying
issues from <2.8 causing sub symbols with data defined properties
to be ignored.

Add some tests.

(refs #13707)

Revision 6bb6929c - 2015-11-18 10:47 AM - Nyall Dawson

Fix data defined overrides for sub symbols in line and marker fill
are not being applied (fix #13707)

(cherry-picked from 2ac59332130186d891635f01c6¢c7677685716863)

Revision ce2a84d6 - 2015-11-18 10:47 AM - Nyall Dawson
Followup 2ac5933 with more data defined fixes

2ac5933 fixed the regression in 2.12, but there were more underlying
issues from <2.8 causing sub symbols with data defined properties
to be ignored.

Add some tests.

(refs #13707)

(cherry-picked from 9e84fcafd8597846367a7417ceOce77f7a4cab587)

History

#1 - 2015-10-29 11:11 AM - David Trethewey

- File qgis212-bugtest-vecpoly-linepattern-minimumexample.zip added

#2 - 2015-10-29 11:24 AM - David Trethewey

- File qgis212-bugtest-vecpoly-linepattern-lessminimalexample.zip added

#3 - 2015-10-29 04:07 PM - David Trethewey

- File qgis212-bugtest-vecpoly-linepattern-lessminimalexample.zip added

#4 - 2015-10-29 04:09 PM - David Trethewey

| just replaced the example project, because the expression for the size of the arrow was incorrect, unfortunately | can't seem to remove the earlier version
of qgis212-bugtest-vecpoly-linepattern-lessminimalexample.zip

#5 - 2015-11-03 01:18 AM - Nyall Dawson
- Status changed from Open to In Progress
- Assignee set to Nyall Dawson

Confirmed and bisected to commit:d6d6827
#6 - 2015-11-03 11:58 AM - Nyall Dawson
- Status changed from In Progress to Closed

Fixed in changeset commit:"2ac59332130186d891635f01c6c7677685716863".

Files

truro-slopearrows-qgis212possbug.jpg 617 KB 2015-10-29 David Trethewey
qgis212-bugtest-vecpoly-linepattern-minimumexample.zip 13.1 KB 2015-10-29 David Trethewey
qgis212-bugtest-vecpoly-linepattern-lessminimalexample.zip 218 KB 2015-10-29 David Trethewey
qgis212-bugtest-vecpoly-linepattern-lessminimalexample.zip 215 KB 2015-10-29 David Trethewey
